SETS
   TT        obdobi   / 1 * 12 /;

PARAMETERS
   D(TT)     poptavka /1 52.4, 2  45.7, 3 45.3, 4 30.3, 5 20.2, 6 13.9, 7 13.4, 8 12.5, 9 22.6, 10 35.0, 11 46.8, 12 54.8/;

SCALAR
*I /300000/
*I /500000/
I /700000/
* vypocet pro jine omezeni investic
* vyse maximalni investice
;

VARIABLE Z ucelova fce, PT(TT), PE(TT), Q;

POSITIVE VARIABLE IK investice do kotle, IKT investice do kondenzacni turbiny, E, T, TP(TT), EP(TT);

EQUATIONS
UCELFCE, INVK, INVKT, ZISKT, ZISKE, OINV, POMER, OTP, OEP, POMER, PRODANET, PENALIZACE;

ZISKT(TT)..    PT(TT)  =E= TP(TT) * 60000;
ZISKE(TT)..    PE(TT)  =E= EP(TT) * 120000;
* zisk za prodej energii

OTP(TT)..      T =G= TP(TT);
*OEP(TT)..      E =G= T - TP(TT);
*PRODANET(TT).. TP(TT) =L= D(TT);
PRODANET(TT).. TP(TT) =L= T * (0.000040702113803*(T**2) - 0.012242216785849*T + 1.142626308481739);
OEP(TT)..      E * ((0.006589317317538 + 0.014765752071559*T + 0.000008440143299*(T**2)) +
               (-0.064697262366540 + 0.003151476275506*T - 0.000040942591828*(T**2))*E +
               (0.003005976938700 -0.000172551397111*T + 0.000002298747491*(T**2))*E**2) =G= T - TP(TT);
POMER(TT)..    EP(TT) =L= (T - TP(TT)) * 0.4;
* omezen na mnozstvi prodanych energii
* prevod zpracovaneho tepla [TJ] na elektrickou energii [MWh]

INVK..     IK =E= T * 12000;
INVKT..    IKT =E= E * 17000;
* investice za jednotlive turbiny
OINV..     IK + IKT =L= I;
* omezeni maximalni investice
PENALIZACE..  Q =E= (SUM(TT, D(TT)) - SUM(TT, TP(TT))) * 10000;
* penalizace za nedodane mnozstvi tepla

UCELFCE..    Z =E= SUM(TT, PT(TT)) + SUM(TT, PE(TT)) - IK - IKT - Q;

MODEL VARIANTY / ALL /;

SOLVE VARIANTY MAXIMIZING Z USING NLP;

DISPLAY Z.L, T.L, E.L, IK.L, IKT.L, Q.L, TP.L, EP.L;

