OPTION NLP = CONOPT

SET
J index promenne /1 * 3/;

PARAMETERS
   XI(J)     poptavky  /1 1050, 2 1400, 3 1750/
   P(J)      pravdepodobnost /1 0.33, 2 0.33, 3 0.33/;

SCALAR
LAMBDAQ /60000/
* penalizace za nedodani 1TJ tepla
LAMBDAT /42000/
* zisk z prodeje 1TJ tepla
;

VARIABLE Z ucelova fce, PT(J), I investice, TP(J), D(J), Q(J);

POSITIVE VARIABLE C vysledna kapacita;

EQUATIONS
UCELFCE, INVESTICE, ZISK, OVL, OVU, ST, OP, OM, PENALE;

INVESTICE..      I =E= 100 * C**0.6;
* investicni funkce
ZISK(J)..        PT(J) =E= LAMBDAT/6000 * (C - tp(J));
* zisk z vyroby tepla
PENALE(J)..      Q(J) =E= D(J) * LAMBDAQ / 6000;
* penale za nedodani poptavaneho tepla
ST(J)..          TP(J) - D(J) =E= C - XI(J) / 7;
* pomocna rovnice
OP(J)..          TP(J) =G= 0;
OM(J)..          D(J) =G= 0;
* zajistena nezapornost
OVL..            C =G= 35;
OVU..            C =L= 500;
* omezeni na velikost spalovny
UCELFCE..        Z =E=  I - SUM (J, (PT(J) - Q(J)) * P(J));

MODEL zjpriklad /ALL/;

SOLVE zjpriklad MINIMIZING Z USING NLP;

DISPLAY Z.L, C.L, I.L, TP.L, D.L, Q.L, PT.L;

